#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "gfuncs.h"

static unsigned int now_id = 0;

unsigned int get_nextid(){
	now_id++;
	
	if(!now_id){
		fprintf(stderr, "too many variables\n");
		exit(1);
	}
	
	return now_id;
}

void *malloc_noerr(size_t size){
	void *ret;
	
	ret = malloc(size);
	if(!ret){
		fprintf(stderr, "malloc failed\n");
		exit(1);
	}
	
	return ret;
}

void *realloc_noerr(void *buf, size_t size){
	void *ret;
	
	ret = realloc(buf, size);
	if(!ret){
		fprintf(stderr, "realloc failed\n");
		exit(1);
	}
	
	return ret;
}

char *copy_string(char *src){
	char *cpy = malloc_noerr(sizeof(char) * (strlen(src) + 1));
	
	strcpy(cpy, src);
	
	return cpy;
}
